CREATE TABLE COURSES
(CCODE  VARCHAR2(5) 
           CONSTRAINT  COURSES_PK PRIMARY KEY,
  CNAME  VARCHAR2(20)
    CONSTRAINT  COURSES_CNAME_NN NOT NULL, 
  DURATION  NUMBER(3),
  TFEE             NUMBER(5),
  LFEE             NUMBER(4),
  DI                 DATE
);

CREATE TABLE BATCHES
( BCODE    VARCHAR2(5) 
    CONSTRAINT     BATCHES_PK PRIMARY KEY,
  CCODE    VARCHAR2(5)
     CONSTRAINT BATCHES_CCODE_FK
          REFERENCES  COURSES(CCODE),
   STDATE  DATE,
   ENDDATE DATE,
    TIMING       VARCHAR2(15),
    TFEE            NUMBER(5),
    LFEE            NUMBER(4),
    DURATION  NUMBER(3),
    CONSTRAINT  BATCHES_DATES_CHK
         CHECK( STDATE <= ENDDATE)
);    
 

CREATE TABLE STUDENTS
(  BCODE  VARCHAR2(5) 
      CONSTRAINT  STUDENTS_BCODE_FK
           REFERENCES BATCHES(BCODE),
   ROLLNO  NUMBER(3),
   SNAME   VARCHAR2(30),
   EMAIL    VARCHAR2(30),
   PHONENO  VARCHAR2(21),
   DJ            DATE,
   LAB          CHAR(1)  DEFAULT 'N'
           CONSTRAINT  STUDENTS_LAB_CHK
             CHECK ( LAB IN ('Y','N')),
   CONSTRAINT  STUDENTS_PK
        PRIMARY KEY(BCODE,ROLLNO)
); 

CREATE TABLE PAYMENTS
( RCPTNO  NUMBER(4)  
     CONSTRAINT  PAYMENTS_PK PRIMARY KEY,
   BCODE    VARCHAR2(5),
   ROLLNO  NUMBER(3),
   DP           DATE,
   AMOUNT  NUMBER(5),
   PTYPE      CHAR(1)  DEFAULT  'F'
     CONSTRAINT  PAYMENTS_PTYPE_CHK
          CHECK( PTYPE IN ('R','L','F')),
   CONSTRAINT  PAYMENTS_BCODE_ROLLNO_FK
           FOREIGN KEY (BCODE,ROLLNO)
           REFERENCES  STUDENTS (BCODE,ROLLNO)
          ON DELETE CASCADE
 );
  
    
 
    




   

